/*
 * $Id: //depot/prod/newport_news/main/modules/nn-codegen/src/main/java/com/netapp/common/generator/CodeFormatter.java#2 $
 *
 * Copyright (c) 2005 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.generator;

/**
 * Define the basic style used by a {@link NetappClassGenerator}
 * @author sirianni
 * @author sunday
 * @version $Revision: #2 $ $Date: 2011/06/24 $
 */
public interface CodeFormatter {
    /**
     * Tab characters
     * @return The characters to use when increasing the indent level
     */
    String tab();

    /**
     * Newline character
     * @return The character(s) to use at the end of a line
     */
    String newLine();

    /**
     * FixMe comment
     * @return The comment to insert for fixme issues
     */
    String fixMe();

    /**
     * ToDo comment
     * @return The comment to insert for ToDo issues
     */
    String toDo();

    /**
     * Default object type
     * @return The java type to use for unspecified declarations
     */
    String defaultType();

    /**
     * File header
     * @return The file header for any generated files
     */
    String fileHeader();

    /**
     * GUID comment
     * @return The comment to insert for GUID comments
     */
    String guid();
}
